<?php 


/* University of Illinois/NCSA Open Source License for lscriptlist.php.

 Copyright (c) 2009/12 Jim Champ/Surrey County Council
 All rights reserved.
 Developed by: 		Jim Champ
 www.devboats.co.uk/lscriptlist
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal with the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimers.

 Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and the following disclaimers
 in the documentation and/or other materials provided with the
 distribution.

 Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
 or promote products derived from this Software without specific prior
 written permission.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.*/

// This next function is for versions of PHP below 5.1 which don't include the fputcsv function
// If you wll never use versions of PHP below 5.1 you can delete it

// **** Start fputcsv code ****

if (!function_exists('fputcsv')) {
	function fputcsv(&$handle, $fields = array(), $delimiter = ',', $enclosure = '"') {
		// this function is example code from php documentation site
		// contributed by jon+dontspamme at phpsitesolutions dot com
		//  30-Jul-2008 05:44
		//it is licensed under the followimg creative commons license
		//  http://uk.php.net/manual/en/cc.license.php
		// the rest of the code is licensed under University of illinois/NCSA.

		// Sanity Check
		if (!is_resource($handle)) {
			trigger_error('fputcsv() expects parameter 1 to be resource, ' .
			gettype($handle) . ' given', E_USER_WARNING);
			return false;
		}

		if ($delimiter!=NULL) {
			if( strlen($delimiter) < 1 ) {
				trigger_error('delimiter must be a character', E_USER_WARNING);
				return false;
			}elseif( strlen($delimiter) > 1 ) {
				trigger_error('delimiter must be a single character', E_USER_NOTICE);
			}

			/* use first character from string */
			$delimiter = $delimiter[0];
		}

		if( $enclosure!=NULL ) {
			if( strlen($enclosure) < 1 ) {
				trigger_error('enclosure must be a character', E_USER_WARNING);
				return false;
			}elseif( strlen($enclosure) > 1 ) {
				trigger_error('enclosure must be a single character', E_USER_NOTICE);
			}

			/* use first character from string */
			$enclosure = $enclosure[0];
		}

		$i = 0;
		$csvline = '';
		$escape_char = '\\';
		$field_cnt = count($fields);
		$enc_is_quote = in_array($enclosure, array('"',"'"));
		reset($fields);

		foreach( $fields AS $field ) {

			/* enclose a field that contains a delimiter, an enclosure character, or a newline */
			if( is_string($field) && (
			strpos($field, $delimiter)!==false ||
			strpos($field, $enclosure)!==false ||
			strpos($field, $escape_char)!==false ||
			strpos($field, "\n")!==false ||
			strpos($field, "\r")!==false ||
			strpos($field, "\t")!==false ||
			strpos($field, ' ')!==false ) ) {

				$field_len = strlen($field);
				$escaped = 0;

				$csvline .= $enclosure;
				for( $ch = 0; $ch < $field_len; $ch++ )    {
					if( $field[$ch] == $escape_char && $field[$ch+1] == $enclosure && $enc_is_quote ) {
						continue;
					}elseif( $field[$ch] == $escape_char ) {
						$escaped = 1;
					}elseif( !$escaped && $field[$ch] == $enclosure ) {
						$csvline .= $enclosure;
					}else{
						$escaped = 0;
					}
					$csvline .= $field[$ch];
				}
				$csvline .= $enclosure;
			} else {
				$csvline .= $field;
			}

			if( $i++ != $field_cnt ) {
				$csvline .= $delimiter;
			}
		}

		$csvline .= "\n";

		return fwrite($handle, $csvline);
	}
}

// **** End of fputcsv code ****



// the program produces an array which then needs to be sent as a download. 
// that means that when that module is called the download headers need to 
// be the first thing sent to the browser, so must be the result of a
// post command. passing a huge array across in a post command was ugly 
// and probably has security implications, so instead we use this temp
// file. The whole utility is maybe more vulnerable to misbehavious than some
// but in any case I can't imagine wanting to ezpose the directory publicly
// anyway. I don't advise exposing this code outside your firewall

// **** OES/Netware change required ****

// For OES you need a path to tmp for the download file
// There will be lots of potential security gotchas in OES, depending on what level of security you 
// have set in the browser and with php. in Netware 6.5 you don't need to bother: it will default to sys:php5.
// If you do want a path in Netware of course you will need to use Netware syntax for the path: sys:/tmp or whatever

//$fptempfile = "/tmp/~tmplscp.txt";  // This line for OES
$fptempfile = "~tmplscp.txt";         // This line for Netware

// string used to identify a download call. Can be anything.
$downloadcmd = "dhgtr71%df";

// start by querying the post variables to determine which code path is in use
//hopefully few systems still use http_post_vars

if (@$_POST['fdownload'] == $downloadcmd) {
	//if we are doing a fle download we must do custome headers and so on, so that's
	//why the first thing to do is to test for that.
	downloadData();
	@unlink($fptempfile);
	exit;
} else {
	if (@$HTTP_POST_VARS['fdownload'] == $downloadcmd ) {
		downloadData();
		@unlink($fptempfile);
		exit;
	}
}

// having got past the download we can display an html header
// the pageheader function contains all the basic HTML, so 
// you can change look and feel there...
pageHeader();

//Second codebranch - if there's text in fdisplay (any text!)
// we assume that we've been through the authentication form and want to query the directory
if (@$_POST['fdisplay'] > "" ) {
	// so thedisplaydata function generates output to screen and preps the doanload file
	displayData();
	exit;
} else {
	if (@$HTTP_POST_VARS['fdisplay'] > "" ) {
		displayData();
		exit;
	}
}

//finally, i we aren't doing anything else, we drop through to here and display the initial
//form to collect authentication data and other parameters

//its easier to construct the HTML form with this syntax rather than use unmpteen echos and things.
$b = <<<HTMLFORM

<!-- Content -->
<form method="POST" action="lscriptlist.php"
	enctype="x-www-form-urlencoded">
	<table summary="User Entry Form">
	<tr>
		<td>LDAP Admin User ID:</td>
		<td><input type="text" name="ldap_id" size="40" maxlength="60" /></td>
	</tr>
	<tr>
		<td>Admin User LDAP Context:</td>
		<td><input type="text" name="ldap_cx" size="40" maxlength="60"
			value="ou=at,ou=your,o=company" /></td>
	</tr>
	<tr>
		<td>LDAP Password:</td>
		<td><input type="password" name="ldap_pw" size="40"
			maxlength="60" /></td>
	</tr>
	<tr>
		<td>LDAP Server:</td>
		<td><input type="text" name="ldap_server" size="40"
			maxlength="60" value="[your LDAP Server]" /></td>
	</tr>
	<tr>
		<td colspan="2">
		<hr />
		</td>
	</tr>
	<tr>
		<td>Search Context:</td>
		<td><input type="text" name="ldap_root" size="40"
			maxlength="60" value="o=company" /></td>
	</tr>
	<tr>
		<td>Report only lines containing string:</td>
		<td><input type="text" name="string_sr" size="40" maxlength="60"
			value="" />
			</td>
		</tr>
		<tr>
			<td>Include line numbers in reports:</td>
			<td><input type="checkbox" name="line_nums" value="enabled"></td>
		</tr>
		<tr>	
			<td>Object Type</td>
			<td >
          		<input type="radio" name="ldap_sr" value="organizationalUnit" checked>OU<br>
          		<input type="radio" name="ldap_sr" value="Organization">O<br>
          		<input type="radio" name="ldap_sr" value="groupOfNames">Group<br>
          		<input type="radio" name="ldap_sr" value="Template">Template<br>
          		<input type="radio" name="ldap_sr" value="inetOrgPerson">User<br>
          		<input type="radio" name="ldap_sr" value="Profile">Profile<br>
          		<!-- here you may add other object classes that contain login scripts according to your schema and how you use your tree -->
          		<!-- or of course remove any you don't want... -->
			</td>
		</tr>

	<tr>
		<td>
			<input type="submit" value="Post Details" />
			<INPUT TYPE="hidden" NAME="fdisplay" VALUE="GoGoGo" >
		</td>
		<td>
			<input type="reset" value="Clear Form" />
		</td>
	</tr>
</table>
<h2>User Notes</h2>
<p>The User ID should be your normal LAN user id. The User LDAP
context should have a default set by your admin. If your user id is
in a different context then alter it approriately, bearing in mind the
need to use LDAP syntax with a comma rather than a stop as the
delimiter.The LDAP Password will be the normal password for the user id.
The LDAP server can be changed if desired, but its probably best to use
the default server or another of the DS master servers in the tree. The
search context is the point at the tree at which the search starts, also 
in LDAP syntax. It can be made blank to search the entire tree. The "report 
only" search string can be blank to display every line or include text. 
Examples could be "map" to display all map lines, or a server name to 
hunt for drive mappings to that particular server. Its not case sensitive. 
Note that if you start your search near the root of the tree and search for
all login scripts for users the search will take some time to complete. Smaller
searches will run more quickly.</p>

HTMLFORM;

echo $b;

//finally a function to ends the html, you may wish to customise this as well
closedocument();
//and the final curtain...
exit;

Function displayData(){

	//There's an issue here if you have older implementations of PHP which use http_post_vars rather than _post.
	//I haven't bothered to put in the extra code since there are none such left at my site and there must be few by now
	//use the code higher up as a model if required.
	
    //there probably ought to be some checking/validation of the data so that there's a pretence at entering reasonable fields
    // if you wish to expose this code outside your network - and personally I would not without a very thorough code audit
    // then there definitely needs to be validation. Its all a bit too open for a public system I think.     
    $ldap_id=$_POST['ldap_id'];
	$ldap_cx=$_POST['ldap_cx'];
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_server=$_POST['ldap_server'];
	$ldap_root=$_POST['ldap_root'];
	$string_sr=$_POST['string_sr'];
	$ldap_sr="objectClass=" . $_POST['ldap_sr'];
	if($_POST['line_nums']=="enabled") {
		$line_nums_enabled=TRUE;
	}
	if(strlen($string_sr)>1) {
		$string_sr_enabled = TRUE;
	}     	
	//we probably don't need to set TRUE like that with a bit of care, but one less thing to test
	
	//lets assemble a dn from the user id and context
	$ldap_id="cn=" . $ldap_id . "," . $ldap_cx;
     
    //some debug stuff left in but commented out... 
	//echo "Line Nums: *$line_nums_enabled*<br>";
    //echo "Search string: *$ldap_sr*<br>";
    //echo "User id: *$ldap_id*<br>";	

	// So we start by connecting to LDAP
     
     echo "<p>Connecting to LDAP server...  ";
     
     $ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!
     
     // echo "\n<p>Connection results".$ds."</p>";
     if (strlen($ldap_pw) <1){
		// if the pw is unset set nonsense in the field...
		// I've spotted some odd behaviour with password apparently kept in cache which is
		// dubious security wise. This ensures it has to be set every time 
		$ldap_pw = "gdhfr76~x8**";
     }
     
     if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
     	echo " ...succeeded</br>\n";
     	// we have now made an LDAP connection
     } else { 
     	echo " failed.</p>\n<h2>LDAP Authentication Failed</h2>\n";
     	echo "<p>User id and/or Password credentials were incorrect</p>\n";
     	echo "<p>User id and context entered was " . $ldap_id . "</p>\n";
     	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
     	echo "correct LDAP syntax (ou=unit,o=org) rather than NDS syntax for the user context.</p>\n";
     	exit;
     
     }

     //echo "Searching in " . $ldap_root , " for " . $ldap_sr . " ...<br>\n";
     // Search surname entry
     
     //always good practice to use the attrs to restrict what the search returns
     //saves memory and performance
     $ldap_attrs=array("cn","loginScript");
     //and do the search
     $sr=ldap_search($ds, $ldap_root, $ldap_sr, $ldap_attrs);  

     //echo "\nSearch result is " . $sr . "<br>\n";
     
	 //and here is the first return
     $entry = @ldap_first_entry($ds, $sr);
     if(@ldap_count_entries($ds, $sr) == 1 ) {
         echo  "1 directory entry returned.</p>\n";
     
     } else {
         echo  @ldap_count_entries($ds, $sr) . " directory entries returned.</p>\n";
     }
     
     // I like to put a download button at the top of the page and the bottom, here's the one at the top
     global $downloadcmd;
     
     echo "<p><FORM METHOD=\"POST\" ACTION=\"lscriptlist.php\" ENCTYPE=\"x-www-form-urlencoded\">";
     echo "<INPUT TYPE=\"hidden\" NAME=\"fdownload\" VALUE=\"$downloadcmd\" >";
     echo "<INPUT TYPE=\"submit\" VALUE=\"Download Output\"></TD>";
     echo "</FORM></p>";
     
     //set a variable for the loginscript data. This is what will be used for
     //the text version download
     $lsdata = "";
     
	 //set some table headers, of course if delivering line nums we need different headers
     if($line_nums_enabled==TRUE) {
 	    $lsdata = "DN,Line Num,ScriptText\r\n";
	 } else {
 	    $lsdata = "DN,Script\r\n";
	 }		
	 //and  now we iterate throught all the LDAP results
     while ($entry) {
     	$attrs = @ldap_get_attributes($ds,$entry);
     	//format a DN for display
     	$udn = @ldap_get_dn($ds,$entry);
     	$udn =  str_ireplace("cn=",".",$udn) ;
     	$udn =  str_ireplace(",ou=",".",$udn) ;
     	$udn =  str_ireplace(",o=",".",$udn) ;
     	$tdn = $udn . ",";
     	
     	//now we check for length of login script, 
		// No half sane login scrpt could have less than 3 characters surely!
     	if (strlen(@$attrs["loginScript"][0] ) > 3) {
     		//put the header tags in teh DN
			$udn =  "<h3>$udn</h3>" ;
			//inistialise the line number counter
			$lnum = 0;
			$disp_num = "";
            echo "$udn <br>"  ;
			
            //now we work on the actual login script
			//explode the login script using the new line chars 
			$arr_lsc = explode("\n", $attrs["loginScript"][0] );
            //iterate through the login script
			foreach($arr_lsc as $lsc_line) {
				//process line nums if required
     			if($line_nums_enabled==TRUE) {
     				$lnum++;
					$disp_num = substr("        " . $lnum . ": " ,-8);
					$dl_num = $lnum . "," ;
     			}
     			//check if we are doing a search for a string in the line		
	            if($string_sr_enabled==TRUE) {
	            	//and if so didplay the line if the string is not not found (!)
	            	if(stripos($lsc_line,$string_sr)!== FALSE) {
						echo $disp_num . $lsc_line . "<br>";
						$lsdata .= $tdn .  $dl_num . $lsc_line;
	            	}
	            	//and of course drop through if the string isn't there
            	} else {
            		//and if we aren't seraching for specific strings just display the line
					echo $disp_num . $lsc_line . "<br>";
					$lsdata .= $tdn .  $dl_num . $lsc_line;
               	}    
            }
		}
        // and next iteration    
     	$entry = ldap_next_entry($ds, $entry);
     }
	 //now we've displayed all the data we can close the table and ldap     
     echo "</table></p>\n";	
     ldap_close($ds);
     
     //and also display a download button at the end...
     echo "<p><FORM METHOD=\"POST\" ACTION=\"lscriptlist.php\" ENCTYPE=\"x-www-form-urlencoded\">";
     echo "<INPUT TYPE=\"hidden\" NAME=\"fdownload\" VALUE=\"$downloadcmd\" >";
     echo "<INPUT TYPE=\"submit\" VALUE=\"Download Output\"></TD>";
     echo "</FORM></p>";

     //so we finish up the display routine by creating the temporary file we will doanload if we choose.
     //note that we always create this
     //note also that because the file name is hard coded there are possibilities for a collision if multiple users do
     //different searches at the same time. We really should do random file names and pass the file name in a hidden value 
     //in the post commenad, so if you are keen feel free [grin]      

     //so the tempfile name is a global
     global $fptempfile;
     //we delete any existing one with errors suppressed
     @unlink($fptempfile);
     //open the file appropriately
     $fhandle = fopen($fptempfile, "wb");
     //and write the string with all the data 
     fwrite($fhandle,$lsdata);
     //close the file
     $r=fclose($fhandle);
     
     //finish off the html page
     closedocument();
     // and done
     exit;
}

Function downloadData(){
	header("Content-Disposition: filename=\"lscriptlist.csv\"");
	header("Content-Type: application/force-download");
	header("Content-Type: application/octet-stream");
	header("Content-Type: application/download");
	header("Content-Description: File Transfer");
	//these two added to try and stop cahing rf PHP docs...
	header("Cache-Control: no-cache"); 
	header("Expires: -1"); 
	global $fptempfile;
	#flush(); // this doesn't really matter.
	readfile($fptempfile);
}


function closedocument(){
	//any page foooter or the like goes here...
	echo "</body>\n</html>\n";
}


function pageHeader(){
	$h= <<<HTMLHEADER
<html>
<head>

<!--
 University of Illinois/NCSA Open Source License for lscriptlist.php.

 Copyright (c) 2009/11 Jim Champ/Surrey County Council
 All rights reserved.
 Developed by: 		Jim Champ
 www.devboats.co.uk/lscriptlist
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal with the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimers.

 Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and the following disclaimers
 in the documentation and/or other materials provided with the
 distribution.

 Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
 or promote products derived from this Software without specific prior
 written permission.
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.

-->

<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>eDirectory Login Script Report Utility</title>
<style>
	table, td, th
	{
		text-align:left;
		vertical-align:top;
		padding:5px;
		border:1px solid black;
		border-collapse:collapse;
	}
</style>

HTMLHEADER;

	echo $h;
	echo "</head>\n";
	echo "<body>\n";
	echo "<div>";
	echo "<H1>eDirectory Login Script Report Utility</H1>";

}
